#include <nl_types.h>
#include <locale.h>
#include <sys/types.h>
#include <sys/localedef.h>
#include <regex.h>
#include <sys/time.h>
#if _LC_VERSION != 1
#error "Required header files sys/localedef.h and sys/lc_core.h are the wrong version or are missing.\
"
#endif
extern int __mbstopcs_sb(wchar_t *, size_t, char *, size_t, int, char**, int *,_LC_charmap_t*);
extern int __mbtopc_sb(wchar_t *, char *, size_t, int*,_LC_charmap_t*);
extern int __pcstombs_sb(char*,size_t,wchar_t*,size_t,char**, int*,_LC_charmap_t*);
extern int __pctomb_sb(char *,wchar_t*,size_t,int*,_LC_charmap_t*);
extern _LC_charmap_t *__charmap_init(_LC_locale_t*);
extern int __mblen_sb(const char*, size_t,_LC_charmap_t*);
extern size_t __mbstowcs_sb(wchar_t*,const char*,size_t,_LC_charmap_t*);
extern size_t __mbtowc_sb(wchar_t*,const char*,size_t,_LC_charmap_t*);
extern char * __nl_csinfo(nl_item,_LC_charmap_t*);
extern size_t __wcstombs_sb(char*,const wchar_t*,size_t,_LC_charmap_t*);
extern size_t __wcswidth_latin(const wchar_t *, size_t,_LC_charmap_t*);
extern int __wctomb_sb( char*, wchar_t,_LC_charmap_t*);
extern size_t __wcwidth_latin(const wchar_t,_LC_charmap_t*);
extern int __fnmatch_sb( const char*,const char*,const char*,int,_LC_collate_t*);
extern int __regcomp_std(regex_t*,const char*,int,_LC_collate_t*);
extern size_t __regerror_std(int,const regex_t*,char*,size_t,_LC_collate_t*);
extern int __regexec_std(const regex_t*,const char*,size_t,regmatch_t*,int,_LC_collate_t*);
extern void __regfree_std(regex_t*,_LC_collate_t*);
extern int __strcoll_sb(const char*,const char*,_LC_collate_t*);
extern size_t __strxfrm_sb(char*,const char*,size_t,_LC_collate_t*);
extern int __wcscoll_std( const wchar_t*,const wchar_t*,_LC_collate_t*);
extern size_t __wcsxfrm_std(wchar_t*,const wchar_t*,size_t,_LC_collate_t*);
extern wctype_t __wctype_std( char *,_LC_ctype_t*);
extern int __iswctype_sb( wchar_t, wctype_t,_LC_ctype_t*);
extern wchar_t __towlower_std( wchar_t,_LC_ctype_t*);
extern wchar_t __towupper_std( wchar_t,_LC_ctype_t*);
extern _LC_locale_t *__locale_init(_LC_locale_t*);
extern struct lconv *__localeconv_std();
extern char *__nl_langinfo_std();
extern _LC_monetary_t *__monetary_init(_LC_locale_t*);
extern char *__nl_moninfo(nl_item,_LC_monetary_t*);
extern size_t __strfmon_std(char*,size_t,const char *,va_list,_LC_monetary_t*);
extern _LC_numeric_t *__numeric_init(_LC_locale_t*);
extern char *__nl_numinfo();
extern _LC_resp_t *__resp_init(_LC_locale_t*);
extern char *__nl_respinfo();
extern int __rpmatch_std();
extern _LC_time_t *__time_init(_LC_locale_t*);
extern char *__nl_timinfo();
extern size_t __strftime_std(char*,size_t,const char*,const struct tm*,_LC_time_t*);
extern char * __strptime_std(const char*,const char*,struct tm*,_LC_time_t*);
extern size_t __wcsftime_std(wchar_t*,size_t,const char*,const struct tm*,_LC_time_t*);
/*------------------------- CHARMAP OBJECT  -------------------------*/
static _LC_charmap_t lc_cmap = {{
	{3, _LC_MAGIC, _LC_VERSION, 168},
	__nl_csinfo,
	__mbtowc_sb,
	__mbstowcs_sb,
	__wctomb_sb,
	__wcstombs_sb,
	__mblen_sb,
	__wcswidth_latin,
	__wcwidth_latin,
	__mbtopc_sb,
	__mbstopcs_sb,
	__pctomb_sb,
	__pcstombs_sb,
	__charmap_init,
	(void *)0,
	},	/* End core */
	"koi8-r",
	1,
	1,
	1,
};

/*------------------------- CHARACTER CLASSES -------------------------*/
static _LC_classnm_t classes[] = {
"alnum",	0x00000002,
"alpha",	0x00000001,
"blank",	0x00000004,
"cntrl",	0x00000008,
"digit",	0x00000010,
"graph",	0x00000020,
"lower",	0x00000040,
"print",	0x00000080,
"punct",	0x00000100,
"space",	0x00000200,
"upper",	0x00000400,
"xdigit",	0x00000800,
};

/*------------------------- UPPER XLATE -------------------------*/
static const wchar_t upper[] = {
0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007, 
0x0008, 0x0009, 0x000a, 0x000b, 0x000c, 0x000d, 0x000e, 0x000f, 
0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017, 
0x0018, 0x0019, 0x001a, 0x001b, 0x001c, 0x001d, 0x001e, 0x001f, 
0x0020, 0x0021, 0x0022, 0x0023, 0x0024, 0x0025, 0x0026, 0x0027, 
0x0028, 0x0029, 0x002a, 0x002b, 0x002c, 0x002d, 0x002e, 0x002f, 
0x0030, 0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037, 
0x0038, 0x0039, 0x003a, 0x003b, 0x003c, 0x003d, 0x003e, 0x003f, 
0x0040, 0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047, 
0x0048, 0x0049, 0x004a, 0x004b, 0x004c, 0x004d, 0x004e, 0x004f, 
0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057, 
0x0058, 0x0059, 0x005a, 0x005b, 0x005c, 0x005d, 0x005e, 0x005f, 
0x0060, 0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047, 
0x0048, 0x0049, 0x004a, 0x004b, 0x004c, 0x004d, 0x004e, 0x004f, 
0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057, 
0x0058, 0x0059, 0x005a, 0x007b, 0x007c, 0x007d, 0x007e, 0x007f, 
0x0080, 0x0081, 0x0082, 0x0083, 0x0084, 0x0085, 0x0086, 0x0087, 
0x0088, 0x0089, 0x008a, 0x008b, 0x008c, 0x008d, 0x008e, 0x008f, 
0x0090, 0x0091, 0x0092, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097, 
0x0098, 0x0099, 0x009a, 0x009b, 0x009c, 0x009d, 0x009e, 0x009f, 
0x00a0, 0x00a1, 0x00a2, 0x00a3, 0x00a4, 0x00a5, 0x00a6, 0x00a7, 
0x00a8, 0x00a9, 0x00aa, 0x00ab, 0x00ac, 0x00ad, 0x00ae, 0x00af, 
0x00b0, 0x00b1, 0x00b2, 0x00a3, 0x00b4, 0x00b5, 0x00b6, 0x00b7, 
0x00b8, 0x00b9, 0x00ba, 0x00bb, 0x00bc, 0x00bd, 0x00be, 0x00bf, 
0x00e0, 0x00e1, 0x00e2, 0x00e3, 0x00e4, 0x00e5, 0x00e6, 0x00e7, 
0x00e8, 0x00e9, 0x00ea, 0x00eb, 0x00ec, 0x00ed, 0x00ee, 0x00ef, 
0x00f0, 0x00f1, 0x00f2, 0x00f3, 0x00f4, 0x00f5, 0x00f6, 0x00f7, 
0x00f8, 0x00f9, 0x00fa, 0x00fb, 0x00fc, 0x00fd, 0x00fe, 0x00ff, 
0x00e0, 0x00e1, 0x00e2, 0x00e3, 0x00e4, 0x00e5, 0x00e6, 0x00e7, 
0x00e8, 0x00e9, 0x00ea, 0x00eb, 0x00ec, 0x00ed, 0x00ee, 0x00ef, 
0x00f0, 0x00f1, 0x00f2, 0x00f3, 0x00f4, 0x00f5, 0x00f6, 0x00f7, 
0x00f8, 0x00f9, 0x00fa, 0x00fb, 0x00fc, 0x00fd, 0x00fe, 0x00ff, 
};

/*------------------------- LOWER XLATE -------------------------*/
static const wchar_t lower[] = {
0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007, 
0x0008, 0x0009, 0x000a, 0x000b, 0x000c, 0x000d, 0x000e, 0x000f, 
0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017, 
0x0018, 0x0019, 0x001a, 0x001b, 0x001c, 0x001d, 0x001e, 0x001f, 
0x0020, 0x0021, 0x0022, 0x0023, 0x0024, 0x0025, 0x0026, 0x0027, 
0x0028, 0x0029, 0x002a, 0x002b, 0x002c, 0x002d, 0x002e, 0x002f, 
0x0030, 0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037, 
0x0038, 0x0039, 0x003a, 0x003b, 0x003c, 0x003d, 0x003e, 0x003f, 
0x0040, 0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067, 
0x0068, 0x0069, 0x006a, 0x006b, 0x006c, 0x006d, 0x006e, 0x006f, 
0x0070, 0x0071, 0x0072, 0x0073, 0x0074, 0x0075, 0x0076, 0x0077, 
0x0078, 0x0079, 0x007a, 0x005b, 0x005c, 0x005d, 0x005e, 0x005f, 
0x0060, 0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067, 
0x0068, 0x0069, 0x006a, 0x006b, 0x006c, 0x006d, 0x006e, 0x006f, 
0x0070, 0x0071, 0x0072, 0x0073, 0x0074, 0x0075, 0x0076, 0x0077, 
0x0078, 0x0079, 0x007a, 0x007b, 0x007c, 0x007d, 0x007e, 0x007f, 
0x0080, 0x0081, 0x0082, 0x0083, 0x0084, 0x0085, 0x0086, 0x0087, 
0x0088, 0x0089, 0x008a, 0x008b, 0x008c, 0x008d, 0x008e, 0x008f, 
0x0090, 0x0091, 0x0092, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097, 
0x0098, 0x0099, 0x009a, 0x009b, 0x009c, 0x009d, 0x009e, 0x009f, 
0x00a0, 0x00a1, 0x00a2, 0x00a3, 0x00a4, 0x00a5, 0x00a6, 0x00a7, 
0x00a8, 0x00a9, 0x00aa, 0x00ab, 0x00ac, 0x00ad, 0x00ae, 0x00af, 
0x00b0, 0x00b1, 0x00b2, 0x00a3, 0x00b4, 0x00b5, 0x00b6, 0x00b7, 
0x00b8, 0x00b9, 0x00ba, 0x00bb, 0x00bc, 0x00bd, 0x00be, 0x00bf, 
0x00c0, 0x00c1, 0x00c2, 0x00c3, 0x00c4, 0x00c5, 0x00c6, 0x00c7, 
0x00c8, 0x00c9, 0x00ca, 0x00cb, 0x00cc, 0x00cd, 0x00ce, 0x00cf, 
0x00d0, 0x00d1, 0x00d2, 0x00d3, 0x00d4, 0x00d5, 0x00d6, 0x00d7, 
0x00d8, 0x00d9, 0x00da, 0x00db, 0x00dc, 0x00dd, 0x00de, 0x00df, 
0x00c0, 0x00c1, 0x00c2, 0x00c3, 0x00c4, 0x00c5, 0x00c6, 0x00c7, 
0x00c8, 0x00c9, 0x00ca, 0x00cb, 0x00cc, 0x00cd, 0x00ce, 0x00cf, 
0x00d0, 0x00d1, 0x00d2, 0x00d3, 0x00d4, 0x00d5, 0x00d6, 0x00d7, 
0x00d8, 0x00d9, 0x00da, 0x00db, 0x00dc, 0x00dd, 0x00de, 0x00df, 
};

/*------------------------- CHAR CLASS MASKS -------------------------*/
static const unsigned int masks[] = {
0x00000008, 0x00000008, 0x00000008, 0x00000008, 
0x00000008, 0x00000008, 0x00000008, 0x00000008, 
0x00000008, 0x0000020c, 0x00000208, 0x00000208, 
0x00000208, 0x00000208, 0x00000008, 0x00000008, 
0x00000008, 0x00000008, 0x00000008, 0x00000008, 
0x00000008, 0x00000008, 0x00000008, 0x00000008, 
0x00000008, 0x00000008, 0x00000008, 0x00000008, 
0x00000008, 0x00000008, 0x00000008, 0x00000008, 
0x00000284, 0x000001a0, 0x000001a0, 0x000001a0, 
0x000001a0, 0x000001a0, 0x000001a0, 0x000001a0, 
0x000001a0, 0x000001a0, 0x000001a0, 0x000001a0, 
0x000001a0, 0x000001a0, 0x000001a0, 0x000001a0, 
0x000008b2, 0x000008b2, 0x000008b2, 0x000008b2, 
0x000008b2, 0x000008b2, 0x000008b2, 0x000008b2, 
0x000008b2, 0x000008b2, 0x000001a0, 0x000001a0, 
0x000001a0, 0x000001a0, 0x000001a0, 0x000001a0, 
0x000001a0, 0x00000ca3, 0x00000ca3, 0x00000ca3, 
0x00000ca3, 0x00000ca3, 0x00000ca3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000001a0, 
0x000001a0, 0x000001a0, 0x000001a0, 0x000001a0, 
0x000001a0, 0x000008e3, 0x000008e3, 0x000008e3, 
0x000008e3, 0x000008e3, 0x000008e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000001a0, 
0x000001a0, 0x000001a0, 0x000001a0, 0x00000008, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000000e3, 0x000000e3, 0x000000e3, 0x000000e3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
0x000004a3, 0x000004a3, 0x000004a3, 0x000004a3, 
};

/*-------------------------   CTYPE OBJECT   -------------------------*/
static _LC_ctype_t lc_ctype = {{
	{4, _LC_MAGIC, _LC_VERSION, 152},
	__towupper_std,
	__towlower_std,
	__wctype_std,
	__iswctype_sb,
	(void *)0,
	(void *)0,
	},	/* End core */
	0,
	255,
	255,
	255,
	upper,
	lower,
	masks,
	(void *)0,
	(void *)0,
	0,
	12,
	classes,
	1,
	0,
};

typedef union {
	wchar_t x[2];
	const wchar_t *p;
} lc_weight_t;
typedef struct {
	char *ce_sym;
	lc_weight_t ce_wgt;
} lc_collel_t;
typedef struct {
	lc_weight_t ct_wgt;
	const lc_collel_t *ct_collel;
} lc_coltbl_t;
typedef struct {
	lc_weight_t ss_act;
	char *ss_src;
	char *ss_tgt;
} lc_subs_t;

typedef struct {
	_LC_core_collate_t core;
	unsigned char co_nord;
	lc_weight_t co_sort;
	wchar_t co_wc_min;
	wchar_t co_wc_max;
	wchar_t co_hbound;
	wchar_t co_col_min;
	wchar_t co_col_max;
	const lc_coltbl_t *co_coltbl;
	unsigned  char co_nsubs;
	const lc_subs_t *co_subs;
} lc_collate_t;
/*------------------------- COLLELLS --------------------------------*/
/*------------------------- COLLTBL ---------------------------------*/
/*------------------------- COLLATE OBJECT  -------------------------*/
static lc_collate_t lc_coll = {{
	{5, _LC_MAGIC, _LC_VERSION, 176},
	__strcoll_sb,
	__strxfrm_sb,
	__wcscoll_std,
	__wcsxfrm_std,
	__fnmatch_sb,
	__regcomp_std,
	__regerror_std,
	__regexec_std,
	__regfree_std,
	(void *)0,
	(void *)0,
	},	/* End core */
	0,
	{ _COLL_FORWARD_MASK | 0 | 0 | 0 | 0,},
	0,
	255,
	0,
	0x0000,
	0x00ff,
	(void *)0,
	0,
	(void *)0,
};

/*------------------------- MONETARY OBJECT  -------------------------*/
static _LC_monetary_t lc_mon={{
	{7, _LC_MAGIC, _LC_VERSION, 152},
	__nl_moninfo,
	__strfmon_std,
	__monetary_init,
	(void *)0,
	},	/* End core */
	"",
	"",
	".",
	"",
	"",
	"",
	"-",
	127,
	127,
	127,
	127,
	127,
	127,
	127,
	127,
	"",
	"",
	"",
	"",
};
/*------------------------- NUMERIC OBJECT  -------------------------*/
static _LC_numeric_t lc_num={{
	{6, _LC_MAGIC, _LC_VERSION, 72},
	__nl_numinfo,
	__numeric_init,
	(void *)0,
	},	/* End core */
	".",
	",",
	(unsigned char *)	"\x03""",
};

static char * era_strings[] = {
(char *)0 };
/*-------------------------   TIME OBJECT   -------------------------*/
static _LC_time_t lc_time={{
	{8, _LC_MAGIC, _LC_VERSION, 488},
	__nl_timinfo,
	__strftime_std,
	__strptime_std,
	__wcsftime_std,
	__time_init,
	(void *)0,
	},	/* End core */
	"%m/%d/%y",
	"%H:%M:%S",
	"%a %b %d %H:%M:%S %Z %Y",
	"",
	{
	"Sun",
	"Mon",
	"Tue",
	"Wed",
	"Thu",
	"Fri",
	"Sat",
	},
	{
	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday",
	},
	{
	"Jan",
	"Feb",
	"Mar",
	"Apr",
	"May",
	"Jun",
	"Jul",
	"Aug",
	"Sep",
	"Oct",
	"Nov",
	"Dec",
	},
	{
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December",
	},
	{
	"AM",
	"PM",
	},
	era_strings,
	"",
	"",
	"",
	"",
	"",
	"",
	"",
};
/*------------------------- MESSAGE OBJECT  -------------------------*/
static _LC_resp_t lc_resp={{
	{9, _LC_MAGIC, _LC_VERSION, 88},
	__nl_respinfo,
	__rpmatch_std,
	__resp_init,
	(void *)0,
	},	/* End core */
	"[yY][[:alpha:]]*",
	"[nN][[:alpha:]]*",
	"y:Y:YES",
	"n:N:NO",
};

/*-------------------------- LCONV STRUCT ---------------------------*/
static struct lconv lc_lconv = {
	".",
	",",
	"\x03""",
	"",
	"",
	".",
	"",
	"",
	"",
	"-",
	127,
	127,
	127,
	127,
	127,
	127,
	127,
	127,
	"",
	"",
};

/*-------------------------- LOCALE OBJECT --------------------------*/
static _LC_locale_t lc_loc={{
	{2, _LC_MAGIC, _LC_VERSION, 608},
	__nl_langinfo_std,
	__localeconv_std,
	__locale_init,
	(void *)0,
	},	/* End core */
	{
	"%m/%d/%y",
	"%H:%M:%S",
	"%a %b %d %H:%M:%S %Z %Y",
	"Sun",
	"Mon",
	"Tue",
	"Wed",
	"Thu",
	"Fri",
	"Sat",
	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday",
	"Jan",
	"Feb",
	"Mar",
	"Apr",
	"May",
	"Jun",
	"Jul",
	"Aug",
	"Sep",
	"Oct",
	"Nov",
	"Dec",
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December",
	"AM",
	"PM",
	".",
	",",
	"y:Y:YES",
	"n:N:NO",
	"",
	"koi8-r",
	(void *)0,
	(void *)0,
	(void *)0,
	(void *)0,
	(void *)0,
	},
	&lc_lconv,
	&lc_cmap,
	(_LC_collate_t *)&lc_coll,
	&lc_ctype,
	&lc_mon,
	&lc_num,
	&lc_resp,
	&lc_time,
};

_LC_locale_t *instantiate(void)
{
	return &lc_loc;
}
